var currentEditBlock = null;


function hideInputs()
{
	if(currentEditBlock != null)
	{
		currentEditBlock.style.display = "none";
	}
	
	currentEditBlock = null;
}

function showInputs(id, args)
{
	if(currentEditBlock != null)
	{
		currentEditBlock.style.display = "none";
	}
	
	currentEditBlock = document.getElementById(id);
	
	var inputs = currentEditBlock.getElementsByTagName("input");
	var selects = currentEditBlock.getElementsByTagName("select");
	
	for(var i = 0; i < inputs.length; i++)
	{
		var input = inputs[i];
		var argCount = parseInt(input.name.substring(3));
		input.value = args[argCount];
	}
	
	for(var i = 0; i < selects.length; i++)
	{
		var select = selects[i];
		var argCount = parseInt(select.name.substring(3));
		
		for(var j = 0; j < select.options.length; j++)
		{
			option = select.options[j];
			if(option.value == args[argCount])
			{
				option.selected = true;
				select.selectedIndex = option.index;
			}
			else
			{
				option.selected = false;
			}
		}
	}	

	currentEditBlock.style.display = "block";
}

function update()
{
	if(currentEditBlock == null)
	{
		return;
	}
	
	var id = currentEditBlock.id;
	
	var args = new Array();
	var display = new Array();
	
	var inputs = currentEditBlock.getElementsByTagName("input");
	var selects = currentEditBlock.getElementsByTagName("select");
	
	for(var i = 0; i < inputs.length; i++)
	{
		var input = inputs[i];
		var argCount = parseInt(input.name.substring(3));
		args[argCount] = input.value;
		display[argCount] = input.value;
		
		//check required fields
		var required = input.getAttribute("required");
		if(required != null && required == "true" && args[argCount].length == 0)
		{
			input.focus();
			alert("The entry field with the focus requires you to enter something.");
			return false;
		}
	}
	
	for(var i = 0; i < selects.length; i++)
	{
		var select = selects[i];
		var argCount = parseInt(select.name.substring(3));
		args[argCount] = select.options[select.selectedIndex].value;
		display[argCount] = select.options[select.selectedIndex].text;
		
		//check required fields
		var required = select.getAttribute("required");
		if(required != null && required == "true" && args[argCount].length == 0)
		{
			select.focus();
			alert("The entry field with the focus requires you to enter something.");
			return false;
		}
	}
	
	parent.abExpression.updateExpression(id, args, display);
}
