var currentFocus = null;
var argCount = 0;

function showExpression()
{
	document.getElementById("no_expression_div").style.display = "none";
	document.getElementById("expression_div").style.display = "block";
}

function activateNoun(id)
{
	if(currentFocus != null)
	{
		if(parent.abEditor.update() == false)
		{
			return false;
		}
		currentFocus.className = "inactiveNoun";
	}
	
	currentFocus = document.getElementById(id);
	currentFocus.className = "activeNoun";
	
	//get all args
	var args = new Array();
	
	var count = 0;
	var arg;
	while((arg = document.getElementById(id + "_arg" + count)) != null)
	{
		args[count] = arg.value;
		count++;
	}
	
	//show the corresponding inputs
	var fieldType = document.getElementById(id + "_type");
	parent.abEditor.showInputs(fieldType.value, args);
}

function removeNoun()
{
	if(currentFocus == null)
	{
		alert("Select a noun to delete.");
		return false;
	}
	
	//prompt for deletion
	if(confirm("Remove selected noun?") == false)
	{
		return false;
	}
	
	var tbody = document.getElementById("expression");
	var tr = currentFocus.parentNode.parentNode;
	if(tr.previousSibling != null && tr.previousSibling.nodeType ==  3) //TEXT_NODE
	{
		if(tr.nextSibling != null)
		{
			tbody.removeChild(tr.nextSibling);
		}
		
		tbody.removeChild(tr);
	}
	else
	{
		tbody.removeChild(tr.previousSibling);
		tbody.removeChild(tr);
	}
	
	currentFocus = null;
	parent.abEditor.hideInputs();
}

function moveNounUp()
{
	if(currentFocus == null)
	{
		alert("Select a noun to move up.");
		return false;
	}
	
	var tbody = document.getElementById("expression");
	var tr = currentFocus.parentNode.parentNode;
	var currentFocusId = currentFocus.id;
	
	if(tr.previousSibling != null && tr.previousSibling.nodeType ==  3) //TEXT_NODE
	{
		//we are at the top
		return;
	}
	
	var tr2 = tr.previousSibling.previousSibling;
	var trTemp = tr.cloneNode(true);
	var tr2Temp = tr2.cloneNode(true);
	
	tbody.replaceChild(tr2Temp, tr);
	tbody.replaceChild(trTemp, tr2);

	currentFocus = document.getElementById(currentFocusId);
}

function moveNounDown()
{
	if(currentFocus == null)
	{
		alert("Select a noun to move down.");
		return false;
	}
	
	var tbody = document.getElementById("expression");
	var tr = currentFocus.parentNode.parentNode;
	var currentFocusId = currentFocus.id;
	
	if(tr.nextSibling == null) //TEXT_NODE
	{
		//we are at the top
		return;
	}
	
	var tr2 = tr.nextSibling.nextSibling;
	var trTemp = tr.cloneNode(true);
	var tr2Temp = tr2.cloneNode(true);
	
	tbody.replaceChild(tr2Temp, tr);
	tbody.replaceChild(trTemp, tr2);

	currentFocus = document.getElementById(currentFocusId);
}

var fields = new Array();
fields["EventField"] = new Array("EventField(", ")", 2, "$arg1arg0");
fields["TextField"] = new Array("", "", 1, "arg0");

function addNoun(id, args)
{
	if(currentFocus != null)
	{
		if(parent.abEditor.update() == false)
		{
			return false;
		}
	}
	
	var prefix = fields[id][0];
	var postfix = fields[id][1];
	var argc = fields[id][2];
	
	var tr = document.createElement("tr");
	var td = document.createElement("td");
		td.setAttribute("valign", "middle");
		td.setAttribute("width", "10");
	var td2 = document.createElement("td");
	
	var concatImg = document.createElement("img");
		concatImg.setAttribute("src", "/nps/portal/modules/naudit/images/ScriptArgTokenNoun.gif");
		concatImg.setAttribute("border", "0");
		concatImg.alt = "expression";
		concatImg.title = "expression";
	
	var target = document.createElement("a");
		target.className = "inactiveNoun";
		target.id = "noun" + argCount;
		target.href = "javascript: activateNoun('noun" + argCount + "');";
		
	var textValue = prefix;
	
	for(var i = 0; i < argc; i++)
	{
		var value = "";
		if(args)
		{
			value = args[i];
		}	
		
		textValue += "\"" + value + "\"";
		
		if(i + 1 != argc)
		{
			textValue += ", ";
		}
	}
	
	textValue += postfix;
	
	var text = document.createTextNode(textValue);
	var type = document.createElement("input");
		type.setAttribute("type", "hidden");
		type.setAttribute("id", "noun" + argCount + "_type");
		type.setAttribute("name", "noun" + argCount + "_type");
		type.setAttribute("value", id);
		
	//put it all together
	tr.appendChild(td);
	tr.appendChild(td2);
	td.appendChild(concatImg);
	td2.appendChild(target);
	target.appendChild(text);
	td2.appendChild(type);
	
	//add hidden fields for arguments and type
	for(var i = 0; i < argc; i++)
	{
		var value = "";
		if(args)
		{
			value = args[i];
		}	
		
		var arg = document.createElement("input");
		arg.setAttribute("type", "hidden");
		arg.setAttribute("id", "noun" + argCount + "_arg" + i);
		arg.setAttribute("name", "noun" + argCount + "_arg" + i);
		arg.setAttribute("value", value);
		td2.appendChild(arg);
	}
	
	
	var expr = document.getElementById("expression");
	var plustr = null;
	
	if(expr.rows.length > 0)
	{
		plustr = document.createElement("tr");
		var plustd = document.createElement("td");
			plustd.setAttribute("valign", "middle");
			plustd.setAttribute("align", "center");
			plustd.setAttribute("width", "10");
		var plustd2 = document.createElement("td");
			
		var plusImg = document.createElement("img");
			plusImg.setAttribute("src", "/nps/portal/modules/naudit/images/ScriptArgTokensConcatenate.gif");
			plusImg.setAttribute("border", "0");
			plusImg.alt = "plus";
			plusImg.title = "plus";
		
		plustr.appendChild(plustd);
		plustr.appendChild(plustd2);
		plustd.appendChild(plusImg);
	}
	else
	{
		showExpression();
	}
	
	if(currentFocus != null)
	{
		parentTr = currentFocus.parentNode.parentNode;
		if(parentTr.nextSibling == null)
		{
			if(plustr != null)
			{
				expr.appendChild(plustr);
			}
			expr.appendChild(tr);
		}
		else
		{
			if(plustr != null)
			{
				expr.insertBefore(tr, parentTr.nextSibling);
				expr.insertBefore(plustr, tr);
			}
			else
			{
				expr.insertBefore(tr, parentTr.nextSibling);
			}
		}
	}
	else
	{
		if(plustr != null)
		{
			expr.appendChild(plustr);
		}
		expr.appendChild(tr);
	}
	
	activateNoun("noun" + argCount);
	argCount++;
}


function updateExpression(idType, args, display)
{
	var prefix = fields[idType][0];
	var postfix = fields[idType][1];
	var argc = fields[idType][2];
	var nounId = currentFocus.id;
	
	var textValue = prefix;
	
	for(var i = 0; i < argc && i < display.length; i++)
	{
		textValue += "\"" + display[i] + "\"";
		
		if(i + 1 != argc)
		{
			textValue += ", ";
		}
	}
	
	textValue += postfix;
	
	var text = document.createTextNode(textValue);
	
	//alert(currentFocus.firstChild);
	currentFocus.replaceChild(text, currentFocus.firstChild);
	
	//update input fields	
	for(var i = 0; i < args.length; i++)
	{
		var argInput = document.getElementById(nounId + "_arg" + i);
		argInput.value = args[i];
	}
}

function createExpression()
{
	if(currentFocus != null)
	{
		if(parent.abEditor.update() == false)
		{
			return false;;
		}
	}
	
	var expression = "";
	var expr = document.getElementById("expression");
	
	var rowcount = expr.rows.length;
	
	for(var i = 0; i < rowcount; i++)
	{
		var row = expr.rows[i];
		var fieldType = null;
		var args = new Array();
		var inputs = row.getElementsByTagName("input"); 
		
		for(var j = 0; j < inputs.length; j++)
		{
			var input = inputs[j];
			var name = input.name;
			if(name.indexOf("_type") != -1)
			{
				fieldType = input.value;
			}
			else if(name.indexOf("_arg") != -1)
			{
				var index = name.indexOf("_arg");
				var argIndex = parseInt(name.substring(index+4));
				args[argIndex] = input.value;
			}	
		}
		
		if(fieldType != null)
		{
			expression += formatString(fields[fieldType][3], args);
		}
	}
	
	parent.done(expression);
}

function formatString(format, args)
{
	for(var i = 0; i < args.length; i++)
	{
		var arg = "arg" + i;
		
		var index = -1;
		while((index = format.indexOf(arg)) != -1)
		{
			format = format.substring(0, index) + args[i] + format.substring(index + arg.length);
		}
	}

	return format;
}


/********** Used for parsing original expression *********************/
var parseStarted = false;
function parseExpression()
{
	if(parseStarted == true)
	{
		return;
	}
	else
	{
		parseStarted = true;
	}
	
	var expr = parent.expression;
	
	if(expr.length <= 0)
	{
		return;
	}
	
	var start = 0;
	var index = -1;
	
	var nouns = new Array();
	var count = 0;
	
	var text = "";
	for(var i = 0; i < expr.length; i++)
	{
		if(expr.charAt(i) == "$")
		{
			if(text.length > 0)
			{
				nouns[count++] = new Array("TextField", text);
				text = "";
			}
						
			nouns[count++] = new Array("EventField", expr.charAt(i+2), expr.charAt(i+1));	//fieldname then format
			i += 2;
		}
		else	
		{
			text += expr.charAt(i);
		}
		
	}
	
	if(text.length > 0)
	{
		nouns[count++] = new Array("TextField", text);
		text = "";
	}
	
	for(var i = 0; i < nouns.length; i++)
	{
		var data = nouns[i];
		var id = data.shift();
		
		addNoun(id, data);
	}
	
	activateNoun("noun0");
}